on construct(me)
  return(1)
  exit
end

on deconstruct(me)
  return(1)
  exit
end

on Refresh(me, tTopic, tdata)
  if me = #msgstruct_numtickets then
    return(me.handle_numtickets(tdata))
  else
    if me = #msgstruct_notickets then
      return(me.handle_notickets(tdata))
    else
      if me = #msgstruct_users then
        return(me.handle_users(tdata))
      else
        if me = #msgstruct_loungeinfo then
          return(me.handle_loungeinfo(tdata))
        else
          if me = #msgstruct_instancenotavailable then
            return(me.handle_instancenotavailable(tdata))
          else
            if me = #msgstruct_gameparameters then
              return(me.handle_gameparameters(tdata))
            else
              if me = #msgstruct_createfailed then
                return(me.handle_createfailed(tdata))
              else
                if me = #msgstruct_gamedeleted then
                  return(me.handle_gamedeleted(tdata))
                else
                  if me = #msgstruct_joinparameters then
                    return(me.handle_joinparameters(tdata))
                  else
                    if me = #msgstruct_joinfailed then
                      return(me.handle_joinfailed(tdata))
                    else
                      if me = #msgstruct_watchfailed then
                        return(me.handle_watchfailed(tdata))
                      else
                        if me = #msgstruct_gamelocation then
                          return(me.handle_gamelocation(tdata))
                        else
                          if me = #msgstruct_startfailed then
                            return(me.handle_startfailed(tdata))
                          else
                            if me = #msgstruct_playerrejoined then
                              return(me.handle_playerrejoined(tdata))
                            else
                              if me = #msgstruct_idlewarning then
                                return(me.handle_idlewarning(tdata))
                              end if
                            end if
                          end if
                        end if
                      end if
                    end if
                  end if
                end if
              end if
            end if
          end if
        end if
      end if
    end if
  end if
  return(0)
  exit
end

on handle_numtickets(me, tMsg)
  tNum = integer(tMsg.getPropRef(#line, 1).getProp(#word, 1))
  if not integerp(tNum) then
    return(0)
  end if
  return(me.getGameSystem().sendGameSystemEvent(#numtickets, tNum))
  exit
end

on handle_notickets(me, tMsg)
  return(me.getGameSystem().sendGameSystemEvent(#notickets, void()))
  exit
end

on handle_users(me, tMsg)
  return(me.getGameSystem().sendGameSystemEvent(#users, tMsg))
  exit
end

on handle_loungeinfo(me, tMsg)
  tConn = tMsg.connection
  tHasTournament = tConn.GetIntFrom()
  if tHasTournament then
    tdata = []
    tdata.addProp(#tournament_logo_url, tConn.GetStrFrom())
    tdata.addProp(#tournament_logo_click_url, tConn.GetStrFrom())
    return(me.getGameSystem().sendGameSystemEvent(#loungeinfo, tdata))
  else
    return(me.getGameSystem().sendGameSystemEvent(#loungeinfo, []))
  end if
  exit
end

on handle_instancenotavailable(me, tMsg)
  tConn = tMsg.connection
  tID = tConn.GetIntFrom()
  return(me.getGameSystem().sendGameSystemEvent(#instancenotavailable, tID))
  exit
end

on handle_gameparameters(me, tMsg)
  tConn = tMsg.connection
  tParamCount = tConn.GetIntFrom()
  tParamList = []
  i = 1
  repeat while i <= tParamCount
    tItem = []
    tItem.addProp(#name, tConn.GetStrFrom())
    ttype = tConn.GetIntFrom()
    if ttype = 0 then
      tItem.addProp(#type, #integer)
      tItem.addProp(#default, tConn.GetIntFrom())
      if tConn.GetIntFrom() = 1 then
        tItem.addProp(#min, tConn.GetIntFrom())
      end if
      if tConn.GetIntFrom() = 1 then
        tItem.addProp(#max, tConn.GetIntFrom())
      end if
    else
      tItem.addProp(#type, #string)
      tItem.addProp(#default, tConn.GetStrFrom())
      tItem.addProp(#choices, [])
      tNumChoices = tConn.GetIntFrom()
      if tNumChoices > 0 then
        i = 1
        repeat while i <= tNumChoices
          tItem.getAt(#choices).append(tConn.GetStrFrom)
          i = 1 + i
        end repeat
      end if
    end if
    tParamList.append(tItem)
    i = 1 + i
  end repeat
  return(me.getGameSystem().sendGameSystemEvent(#gameparameters, tParamList))
  exit
end

on handle_createfailed(me, tMsg)
  tConn = tMsg.connection
  tReason = tConn.GetIntFrom()
  tReasonStr = me.get_instance_error_str(tReason)
  if tReason = 1 then
    tdata = [#reason:tReason, #request:"create", #reasonstr:tReasonStr, #key:tConn.GetStrFrom()]
  else
    tdata = [#reason:tReason, #request:"create", #reasonstr:tReasonStr]
  end if
  return(me.getGameSystem().sendGameSystemEvent(#createfailed, tdata))
  exit
end

on handle_gamedeleted(me, tMsg)
  tConn = tMsg.connection
  tID = tConn.GetIntFrom()
  return(me.getGameSystem().sendGameSystemEvent(#gamedeleted, tID))
  exit
end

on handle_joinparameters(me, tMsg)
  tConn = tMsg.connection
  tInstanceId = tConn.GetIntFrom()
  tParamCount = tConn.GetIntFrom()
  tParamList = []
  i = 1
  repeat while i <= tParamCount
    tItem = []
    tItem.addProp(#name, tConn.GetStrFrom())
    ttype = tConn.GetIntFrom()
    if ttype = 0 then
      tItem.addProp(#type, #integer)
      tItem.addProp(#default, tConn.GetIntFrom())
      if tConn.GetIntFrom() = 1 then
        tItem.addProp(#min, tConn.GetIntFrom())
      end if
      if tConn.GetIntFrom() = 1 then
        tItem.addProp(#max, tConn.GetIntFrom())
      end if
    else
      tItem.addProp(#type, #string)
      tItem.addProp(#default, tConn.GetStrFrom())
      tItem.addProp(#choices, [])
      tNumChoices = tConn.GetIntFrom()
      if tNumChoices > 0 then
        i = 1
        repeat while i <= tNumChoices
          tItem.getAt(#choices).append(tConn.GetStrFrom)
          i = 1 + i
        end repeat
      end if
    end if
    tParamList.append(tItem)
    i = 1 + i
  end repeat
  return(me.getGameSystem().sendGameSystemEvent(#joinparameters, tParamList))
  exit
end

on handle_joinfailed(me, tMsg)
  tConn = tMsg.connection
  tReason = tConn.GetIntFrom()
  tReasonStr = me.get_instance_error_str(tReason)
  if tReason = 1 then
    tdata = [#request:"join", #reason:tReason, #reasonstr:tReasonStr, #key:tConn.GetStrFrom()]
  else
    tdata = [#request:"join", #reason:tReason, #reasonstr:tReasonStr]
  end if
  return(me.getGameSystem().sendGameSystemEvent(#joinfailed, tdata))
  exit
end

on handle_watchfailed(me, tMsg)
  tConn = tMsg.connection
  tInstanceId = tConn.GetIntFrom()
  tReason = tConn.GetIntFrom()
  tReasonStr = me.get_instance_error_str(tReason)
  return(me.getGameSystem().sendGameSystemEvent(#watchfailed, [#id:tInstanceId, #request:"watch", #reason:tReason, #reasonstr:tReasonStr]))
  exit
end

on handle_gamelocation(me, tMsg)
  tConn = tMsg.connection
  tUnitId = tConn.GetIntFrom()
  tWorldId = tConn.GetIntFrom()
  return(me.getGameSystem().sendGameSystemEvent(#gamelocation, [#unitId:tUnitId, #worldId:tWorldId]))
  exit
end

on handle_startfailed(me, tMsg)
  tConn = tMsg.connection
  tReason = tConn.GetIntFrom()
  tReasonStr = me.get_instance_error_str(tReason)
  return(me.getGameSystem().sendGameSystemEvent(#startfailed, [#reason:tReason, #request:"start", #reasonstr:tReasonStr]))
  exit
end

on handle_playerrejoined(me, tMsg)
  tConn = tMsg.connection
  tID = tConn.GetIntFrom()
  return(me.getGameSystem().sendGameSystemEvent(#playerrejoined, [#id:tID]))
  exit
end

on handle_idlewarning(me, tMsg)
  return(me.getGameSystem().sendGameSystemEvent(#idlewarning, void()))
  exit
end

on get_instance_error_str(me, tReason)
  if me = 0 then
    return("nospace")
  else
    if me = 1 then
      return("invalidparam")
    else
      if me = 2 then
        return("notickets")
      else
        if me = 3 then
          return("noskill")
        else
          if me = 4 then
            return("dailylimit")
          else
            if me = 5 then
              return("blockedip")
            else
              if me = 6 then
                return("kicked")
              else
                if me = 7 then
                  return("alreadythere")
                else
                  if me = 8 then
                    return("noplayers")
                  end if
                end if
              end if
            end if
          end if
        end if
      end if
    end if
  end if
  return("")
  exit
end